-- Main Panel

-- Zone points of interest:
-- Innkeeper = gives capture cubes
-- MailBox = gives ?
-- Faction Leader (city) = ??
--

-- item types = Cubes (ammo for capturing), cube speed modifier (slows down throw power meter), Luck modifier (increase capture chance)


-- Individual Panels (Assigned later)
local playerPanel = nil
 wowkedexPanel = nil
local localinfoPanel = nil
local pvpPanel = nil
local originPanel = nil




-- Panel Text data
local playerPanelText = ("Level: "..WowkemonPlayerData["level"].." \n \nXP:    "..WowkemonPlayerData["XP"].. "\n \nTotal wowkemon caught: NA");
local wowkedexPanelText = ("Coming soon!")
local localInfoPanelText = ("Data not updated")
-- wowkemon info, player info, inventory, local data,
local PanelBackdrop =
{
    bgFile = WDir.."\\resources\\textures\\misc\\MainPanelBG.tga",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    tile = false, tileSize = 16, edgeSize = 16,
    insets = { left = 3, right = 3, top = 5, bottom = 3 }
}
local HeaderBackdrop =
{
    bgFile = "",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    tile = false, tileSize = 16, edgeSize = 16,
    insets = { left = 3, right = 3, top = 5, bottom = 3 }
}


function wowkemonUpdateTotalCaught()
  local totalCaught = 0;
  for e in pairs(WowkemonPlayerData["Wowkedex"]) do
    totalCaught = totalCaught + 1;
  end

  local totalAvailableTally = 0;
  local totalWowkemonImplemented;
  for e in pairs(Wowkemons) do
    totalAvailableTally = totalAvailableTally + 1;
  end
playerPanelText = ("Level: "..WowkemonPlayerData["level"].." \n \nXP:    "..WowkemonPlayerData["XP"].. "\n \nTotal wowkemon caught: "..totalCaught.."/"..totalAvailableTally);
end
-- core panels
WowkemonMenuBody = CreateFrame("Frame","WowkedexMainPanel",UIParent);
WowkemonMenuBody:SetSize(400,500)
WowkemonMenuBody:SetBackdrop(PanelBackdrop)
WowkemonMenuBody:SetPoint("TOP");
WowkemonMenuBody:SetMovable(true)
WowkemonMenuBody:EnableMouse(true)
WowkemonMenuBody:RegisterForDrag("LeftButton")
WowkemonMenuBody:SetScript("OnDragStart", WowkemonMenuBody.StartMoving)
WowkemonMenuBody:SetScript("OnDragStop", WowkemonMenuBody.StopMovingOrSizing)
 WowkemonMenuBody:Hide()
WowkemonMenuBody:SetScript("OnUpdate",  function() if CaptureWindowLive == true or WowkemonMessageLive == true then
    WowkemonMenuScreenWindow:Hide()
    WowkemonMenuCoreOptions:Hide()
  else
    WowkemonMenuScreenWindow:Show()
    WowkemonMenuCoreOptions:Show()
  end
  end)
WowkemonMenuScreenWindow = CreateFrame("Frame","WowkedexScreenWindowFrame",WowkemonMenuBody)
WowkemonMenuScreenWindow:SetSize(330,300)
WowkemonMenuScreenWindow:SetPoint("TOP",WowkemonMenuBody,"TOP",0,-30)
WowkemonMenuScreenWindow:SetBackdrop(HeaderBackdrop)
WowkemonMenuScreenWindow.BG = WowkemonMenuScreenWindow:CreateTexture(nil,"BACKGROUND",-7)
WowkemonMenuScreenWindow.BG:SetHeight(WowkemonMenuScreenWindow:GetHeight() -15)
WowkemonMenuScreenWindow.BG:SetWidth(WowkemonMenuScreenWindow:GetWidth() -15)
WowkemonMenuScreenWindow.BG:SetColorTexture(0,0,0,1)
WowkemonMenuScreenWindow.BG:SetPoint("CENTER")
WowkemonMenuBody.dpad = WowkemonMenuBody:CreateTexture(nil,"OVERLAY",2)
WowkemonMenuBody.dpad:SetTexture(WDir.."\\resources\\textures\\misc\\dpad.tga")
WowkemonMenuBody.dpad:SetSize(128,128)
WowkemonMenuBody.dpad:SetPoint("BOTTOMLEFT",WowkemonMenuBody,"BOTTOMLEFT",10,10)

WowkemonMenuBody.Btn1= WowkemonMenuBody:CreateTexture(nil,"OVERLAY",2)
WowkemonMenuBody.Btn1:SetTexture(WDir.."\\resources\\textures\\misc\\button.tga")
WowkemonMenuBody.Btn1:SetSize(128,128)
WowkemonMenuBody.Btn1:SetPoint("BOTTOMRIGHT",WowkemonMenuBody,"BOTTOMRIGHT",-40,110)
WowkemonMenuBody.Btn1:SetScale(0.5)
WowkemonMenuBody.Btn2= WowkemonMenuBody:CreateTexture(nil,"OVERLAY",2)
WowkemonMenuBody.Btn2:SetTexture(WDir.."\\resources\\textures\\misc\\button.tga")
WowkemonMenuBody.Btn2:SetSize(128,128)
WowkemonMenuBody.Btn2:SetScale(0.5)
WowkemonMenuBody.Btn2:SetPoint("BOTTOMRIGHT",WowkemonMenuBody,"BOTTOMRIGHT",-120,60)
WowkemonMenuBody.CloseBtn = CreateFrame("Button","wowkedexCloseButton",WowkemonMenuBody,"UIPanelButtonTemplate");
WowkemonMenuBody.CloseBtn:SetNormalTexture(WDir.."\\resources\\textures\\misc\\powerbtn.tga")
WowkemonMenuBody.CloseBtn:SetSize(25,25)
WowkemonMenuBody.CloseBtn:SetPoint("TOPRIGHT",WowkemonMenuBody,"TOPRIGHT",-5,-5)
WowkemonMenuBody.CloseBtn:SetScript("OnClick", function () StopMusic() WildWowkemonIsAvailable = false WowkemonMenuBody:Hide();  WowkemonCaptureFrame:Hide()  HideAllWindowChildren() end);

-- "Screen window" content panels
 -- Navigation panel
WowkemonMenuCoreOptions = CreateFrame("Frame","WowkedexCoreOptions",WowkemonMenuBody)
WowkemonMenuCoreOptions:SetHeight(35)
WowkemonMenuCoreOptions:SetWidth(WowkemonMenuScreenWindow.BG:GetWidth() -15)
WowkemonMenuCoreOptions:SetPoint("TOP",WowkemonMenuScreenWindow,"TOP",0,-5)
WowkemonMenuCoreOptions:SetBackdrop(HeaderBackdrop)

WowkemonMenuCoreOptions.player = CreateFrame("Button",nil,WowkemonMenuCoreOptions,"UIPanelButtonTemplate")
WowkemonMenuCoreOptions.player:SetText("Player")
WowkemonMenuCoreOptions.player:SetSize(50,25)
WowkemonMenuCoreOptions.player:SetPoint("LEFT",WowkemonMenuCoreOptions,"LEFT",0,0)
WowkemonMenuCoreOptions.player:SetScript("OnClick", function () if playerPanel:IsShown() == false then HideAllWindowChildren(); playerPanel.textContent:SetText("") wowkemonUpdateTotalCaught() playerPanel:Show(); WowkedexBootSequenceTextAnimation(playerPanelText,playerPanel) end end)
WowkemonMenuCoreOptions.wowkedex = CreateFrame("Button",nil,WowkemonMenuCoreOptions,"UIPanelButtonTemplate")
WowkemonMenuCoreOptions.wowkedex:SetText("Wowkedex")
WowkemonMenuCoreOptions.wowkedex:SetSize(80,25)
WowkemonMenuCoreOptions.wowkedex:SetPoint("LEFT",WowkemonMenuCoreOptions,"LEFT",55,0)
WowkemonMenuCoreOptions.wowkedex:SetScript("OnClick",function () HideAllWindowChildren(); wowkedexPanel.textContent:SetText("") WowkedexScrollFrame = makeScrollerFrame(wowkedexPanel) wowkedexPanel:Show(); WowkedexBootSequenceTextAnimation("",wowkedexPanel) end)
WowkemonMenuCoreOptions.localinfo = CreateFrame("Button",nil,WowkemonMenuCoreOptions,"UIPanelButtonTemplate")
WowkemonMenuCoreOptions.localinfo:SetText("Local info")
WowkemonMenuCoreOptions.localinfo:SetSize(75,25)
WowkemonMenuCoreOptions.localinfo:SetPoint("LEFT",WowkemonMenuCoreOptions,"LEFT",140,0)
WowkemonMenuCoreOptions.localinfo:SetScript("OnClick", function ()
  if localinfoPanel:IsShown() == false then
  HideAllWindowChildren();
  localinfoPanel.textContent:SetText("")
  localinfoPanel:Show();
  local curRegion,data = GetInstanceInfo()
  if curRegion == "Eastern Kingdoms" or curRegion == "Kalimdor" then
  refreshTextVariables(false)
  forceRefreshLocalInfo(false)
else
  WowkedexBootSequenceTextAnimation("GPS Signal Lost.. Please try again later.",localinfoPanel)
end
end
end)
WowkemonMenuCoreOptions.pvp = CreateFrame("Button",nil,WowkemonMenuCoreOptions,"UIPanelButtonTemplate")
WowkemonMenuCoreOptions.pvp:SetText("PVP")
WowkemonMenuCoreOptions.pvp:SetSize(75,25)
WowkemonMenuCoreOptions.pvp:SetPoint("LEFT",WowkemonMenuCoreOptions,"LEFT",220,0)
WowkemonMenuCoreOptions.pvp:SetScript("OnClick", function() HideAllWindowChildren(); pvpPanel.textContent:SetText("") WowkedexBootSequenceTextAnimation("|cffFF0000 <IN DEVELOPMENT!>\nThis feature is currently in Alpha testing\nand has limited features!|r\n\nChallenge another player to Battle! \nTarget must be a member of your party.",pvpPanel) pvpPanel:Show() end)

-- Content Panels
-- Parent for all content panels
WowkemonMenuScreenWindow.contentPanel = CreateFrame("Frame","WowkemonScreenContentContainer",WowkemonMenuScreenWindow)
WowkemonMenuScreenWindow.contentPanel:SetHeight(WowkemonMenuScreenWindow:GetHeight() - WowkemonMenuCoreOptions:GetHeight());
WowkemonMenuScreenWindow.contentPanel:SetWidth(WowkemonMenuScreenWindow:GetWidth() - 10)
WowkemonMenuScreenWindow.contentPanel:SetPoint("BOTTOM",WowkemonMenuScreenWindow,"BOTTOM")
-- Player panel
playerPanel = CreateFrame("Frame","WowkemonScreenPlayerPanel",WowkemonMenuScreenWindow.contentPanel)
playerPanel:SetSize(WowkemonMenuScreenWindow.contentPanel:GetSize())
playerPanel:SetPoint("CENTER",WowkemonMenuScreenWindow.contentPanel,"CENTER")
-- playerPanel:SetBackdrop(PanelBackdrop)
playerPanel:Hide()
  -- player panel content
  playerPanel.textContent = playerPanel:CreateFontString(nil,"OVERLAY","GameFontNormal")
  playerPanel.textContent:SetPoint("TOPLEFT",25,-25)
  playerPanel.textContent:SetJustifyH("LEFT");
  playerPanel.textContent:SetJustifyV("TOP");
  playerPanel.textContent:SetTextColor(0.4,0.4,0.4,1)
  playerPanel.textContent:SetText("player panel text")
-- Wowkedex Panel
wowkedexPanel = CreateFrame("Frame","WowkemonScreenWowkedexPanel",WowkemonMenuScreenWindow.contentPanel)
wowkedexPanel:SetSize(WowkemonMenuScreenWindow.contentPanel:GetSize())
wowkedexPanel:SetPoint("CENTER",WowkemonMenuScreenWindow.contentPanel,"CENTER")
-- wowkedexPanel:Hide();
  wowkedexPanel.textContent = wowkedexPanel:CreateFontString(nil,"OVERLAY","GameFontNormal")
  wowkedexPanel.textContent:SetPoint("TOPLEFT",25,-25)
  wowkedexPanel.textContent:SetJustifyH("LEFT");
  wowkedexPanel.textContent:SetJustifyV("TOP");
  wowkedexPanel.textContent:SetText("")
  wowkedexPanel.textContent:SetTextColor(0.4,0.4,0.4,1)

  wowkemonPanel = CreateFrame("Frame","WowkemonInfo",WowkemonMenuScreenWindow)
  wowkemonPanel:SetSize(wowkedexPanel:GetSize());
  wowkemonPanel:SetPoint("TOPLEFT",WowkemonMenuScreenWindow,"TOPLEFT")
  wowkemonPanel.textContent = wowkemonPanel:CreateFontString(nil,"OVERLAY","GameFontHighlight");
  wowkemonPanel.textContent:SetPoint("TOPLEFT")
  wowkemonPanel.textContent:SetJustifyH("LEFT");
  wowkemonPanel.textContent:SetJustifyV("TOP");
  wowkemonPanel.textContent:SetText("initial")

  wowkemonPanel:Hide()
-- Help Panel
-- local info panel
localinfoPanel = CreateFrame("Frame","WowkemonScreenLocalInfoPanel",WowkemonMenuScreenWindow.contentPanel)
localinfoPanel:SetSize(WowkemonMenuScreenWindow.contentPanel:GetSize())
localinfoPanel:SetPoint("CENTER",WowkemonMenuScreenWindow.contentPanel,"CENTER")
localinfoPanel:Hide();
  localinfoPanel.textContent = localinfoPanel:CreateFontString(nil,"OVERLAY","GameFontNormal")
  localinfoPanel.textContent:SetPoint("TOPLEFT",25,-25)
  localinfoPanel.textContent:SetJustifyH("LEFT");
  localinfoPanel.textContent:SetJustifyV("TOP");
  localinfoPanel.textContent:SetText("local info")
  localinfoPanel.textContent:SetTextColor(0.4,0.4,0.4,1)
-- Help Panel
pvpPanel = CreateFrame("Frame","WowkemonScreenLocalInfoPanel",WowkemonMenuScreenWindow.contentPanel)
pvpPanel:SetSize(WowkemonMenuScreenWindow.contentPanel:GetSize())
pvpPanel:SetPoint("CENTER",WowkemonMenuScreenWindow.contentPanel,"CENTER")
  pvpPanel.textContent = pvpPanel:CreateFontString(nil,"OVERLAY","GameFontNormal");
  pvpPanel.textContent:SetPoint("TOPLEFT",pvpPanel,"TOPLEFT",15,-30)
  pvpPanel.textContent:SetJustifyH("LEFT");
  pvpPanel.textContent:SetJustifyV("TOP");
  pvpPanel.SetChallenge = CreateFrame("Button","WowkemonChallengeTargetButton",pvpPanel,"UIPanelButtonTemplate");
  pvpPanel.SetChallenge:SetSize(100,30);
  pvpPanel.SetChallenge:SetText("Challenge Target");
  pvpPanel.SetChallenge:SetPoint("CENTER");
  pvpPanel.SetChallenge:SetScript("OnClick", function ()
    if UnitName("target") ~= nil then
       SendChatMessage(UnitName("player").." has challenged "..UnitName("target").." to a wowkemon Battle!","PARTY")
      WowkemonSendChallengeRequest(UnitName("target"));
    else
      print("You have no target.")
    end
  end)
pvpPanel:Hide();
-- Origin Panel (Displayed on all initial show calls)
originPanel = CreateFrame("Frame","WowkemonScreenOriginPanel",WowkemonMenuScreenWindow.contentPanel)
originPanel:SetSize(WowkemonMenuScreenWindow.contentPanel:GetSize())
originPanel:SetPoint("CENTER",WowkemonMenuScreenWindow.contentPanel,"CENTER")
  originPanel.textContent = originPanel:CreateFontString(nil,"OVERLAY","GameFontNormal")
  originPanel.textContent:SetText("Welcome to your Wowkemonimajig! \n Please select an option.")
  originPanel.textContent:SetTextColor(0.4,0.4,0.4,1)
  originPanel.textContent:SetPoint("TOP",0,-25)



-- First load text "animation" sequence.
function WowkedexBootSequenceTextAnimation(inString,panel)
  local bootString = "";
  local targetPanel = panel
  if inString == nil then
  bootString = "Welcome to your Wowkemonimajig! \n Please select an option."
else
   bootString = inString
end
if targetPanel == nil then
  targetPanel = originPanel
end
  local delay = 0.1
  local delayMultiplier = 1;
  local length = string.len(bootString)
  local distance = 1;
  for i = 1,length do
    distance = distance + 1
    Wowkemon__wait((0.05*distance),SetWowkedexOriginPanelText,string.upper(string.sub(bootString,1,distance)),targetPanel)
  end
end

function SetWowkedexOriginPanelText(input,panel)
  panel.textContent:SetText(input)
end

function HideAllWindowChildren()
  playerPanel:Hide()
  pvpPanel:Hide();
  wowkedexPanel:Hide()
  localinfoPanel:Hide();
  originPanel:Hide()
  wowkedexPanel:Hide()
  wowkemonPanel:Hide()
  WowkemonMessageLive = false;
  CaptureWindowLive = false;
  if WowkemonChatFrame ~= nil then
  WowkemonChatFrame:Hide()
end
originPanel.textContent:SetText("");
  end

function openMainWowkedexPanel()
WowkemonMenuBody:Show()
HideAllWindowChildren();
originPanel:Show()
WowkedexBootSequenceTextAnimation()
end

function loadWowkedexWindowPanel(panel)
panel:Show();
end
WowkedexBootSequenceTextAnimation()

function refreshTextVariables(transition)
  if transition == true then
     localInfoPanelText = "Receiving Update.."
     forceRefreshLocalInfo(true)
   else
     playerPanelText = ("Level: "..WowkemonPlayerData["level"].." \n \nXP:    "..WowkemonPlayerData["XP"].. "\n \nTotal wowkemon caught: N/A")
     local POI = "Points of Interest: \n";
     if PointsOfInterest[GetZoneText()] ~= nil then
       for e in pairs(PointsOfInterest[GetZoneText()]) do
         POI = POI ..PointsOfInterest[GetZoneText()][e].type.."\n"
       end
       localInfoPanelText = ("Region: "..GetInstanceInfo().." \nZone: "..GetZoneText().. "\n\n"..POI)
     else
      localInfoPanelText = ("Region: "..GetInstanceInfo().." \nZone: "..GetZoneText().. "\n\n".."No POI Data available.")
     end
   end
end

function forceRefreshLocalInfo(transition)
  if transition == true then
    WowkedexBootSequenceTextAnimation(localInfoPanelText,localinfoPanel)
  else
    if localinfoPanel:IsShown() == true then
      HideAllWindowChildren();
      localinfoPanel.textContent:SetText("")
      localinfoPanel:Show();
      local curRegion,data = GetInstanceInfo()
      if curRegion == "Eastern Kingdoms" or curRegion == "Kalimdor" then
        WowkedexBootSequenceTextAnimation(localInfoPanelText,localinfoPanel)
      else
        WowkedexBootSequenceTextAnimation("GPS Signal Lost.. Please try again later.",localinfoPanel)
      end
    end
  end
end
